#include <timer.h>
#include <incap.h>
#include "config_Input_capture_33f_util.h"

// las variables de pulso y los pines los declaro en otro archivp
extern  unsigned int pulso_1,pulso_2,pulso_3,pulso_4;



 //variables usadas para calculo
unsigned int pul1_1=0,pul1_2=0;
unsigned int pul2_1=0,pul2_2=0;
unsigned int pul3_1=0,pul3_2=0;
unsigned int pul4_1=0,pul4_2=0;


void config_inputcapure()

{
 OpenTimer2(T2_ON & T2_GATE_OFF &T2_PS_1_64 & T2_SOURCE_INT , 65535);
IC1CON=0;
IC2CON=0;
IC7CON=0;
IC8CON=0; //limpia registo

IC1CONbits.ICTMR=IC2CONbits.ICTMR=IC7CONbits.ICTMR=IC8CONbits.ICTMR=1; //1=timer 2 es la fuente de reloj 0= timer 3

//  Captura cada flanco de subida o bajada
IC1CONbits.ICM=IC2CONbits.ICM=IC7CONbits.ICM=IC8CONbits.ICM=0b001;

//habilita la interrupcion
_IC1IF=_IC2IF=_IC7IF=_IC8IF=0;   // limnpia la bandera
_IC1IE=_IC2IE=_IC7IE=_IC8IE=1;  //habilita las interrpcion

//Priorad d ela interrupcion
SetPriorityIntIC1(3);
SetPriorityIntIC2(3);
SetPriorityIntIC7(3);
SetPriorityIntIC8(3);

}

void __attribute__((__interrupt__,__auto_psv__)) _IC1Interrupt(void)
{

pul1_2=IC1BUF;
 if (in_pulso_1==0)
 {
 //Para medir ancho de pulso
if (pul1_2>pul1_1) pulso_1=(pul1_2-pul1_1);
else pulso_1=(PR2 - pul1_1) + pul1_2;   //desborde del timer
  }
 pul1_1=pul1_2;
_IC1IF=0; // limpia la bandera
}


void __attribute__((__interrupt__,__auto_psv__)) _IC2Interrupt(void)
{

pul2_2=IC2BUF;

 if (in_pulso_2==0)
 {
 //Para medir ancho de pulso
if (pul2_2>pul2_1) pulso_2=(pul2_2-pul2_1);
else pulso_2=(PR2 - pul2_1) + pul2_2;
 }
 pul2_1=pul2_2;
_IC2IF=0;
}


void __attribute__((__interrupt__,__auto_psv__)) _IC7Interrupt(void)

{
pul3_2=IC7BUF;
 if (in_pulso_3==0)
 {
 //Para medir ancho de pulso
if (pul3_2>pul3_1) pulso_3=(pul3_2-pul3_1);
else pulso_3=(PR2 - pul3_1) + pul3_2;
 }
 pul3_1=pul3_2;
_IC7IF=0;
}

void __attribute__((__interrupt__,__auto_psv__)) _IC8Interrupt(void)
{

pul4_2=IC8BUF;

 if (in_pulso_4==0)
 {
 //Para medir ancho de pulso
if (pul4_2>pul4_1) pulso_4=(pul4_2-pul4_1);
else pulso_4=(PR2 - pul4_1) + pul4_2;
 }
 pul4_1=pul4_2;
_IC8IF=0;
}

